
#define LM_ALL
#include "lightmat.h"
#include "fstream"
doubleNNN Reader3(RWCString const & s) {
  doubleNNN tmp;
  std::ifstream f(s.data);
  if (!f) return tmp;
  int s1,s2,s3;
  f>>s1>>s2>>s3;
  tmp.SetShape(s1,s2,s3); 
  for (int i=1; i<=s1; i++)  	
   for (int j=1; j<=s2; j++)  	
    for (int k=1; k<=s3; k++)
      f>>tmp(i,j,k);  	
   	
  return tmp;
}


void Writer3(RWCString const & s, const doubleNNN & tmp) {
  
  std::ofstream f(s.data);
  if (!f) return ;
  int s1=tmp.dimension(1);
  int s2=tmp.dimension(2);
  int s3=tmp.dimension(3);
  f << s1 << " " << s2 << " " << s3 << endl;  
  for (int i=1; i<=s1; i++)  	
   for (int j=1; j<=s2; j++) {  	
    
    for (int k=1; k<=s3; k++)
      f<<" " <<tmp(i,j,k);  	
    f<< endl; 
    }
  f << endl; 	
 
}
